"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@material-ui/core");

var _Container = _interopRequireDefault(require("@material-ui/core/Container"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _utils = require("../../utils");

var _common = require("../common");

var _CustomHeaderProvider = require("../CustomHeaderProvider");

var _Methods = _interopRequireDefault(require("../Methods"));

var _Notifications = require("../Notifications");

var _Params = _interopRequireDefault(require("../Params"));

var _ResponseProvider = require("../ResponseProvider");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// import clsx from "clsx";
// import Responses from "../Responses";
var Layout = function Layout(_ref) {
  var api = _ref.api,
      tree = _ref.tree;

  var _useCustomHeaders = (0, _CustomHeaderProvider.useCustomHeaders)(),
      headers = _useCustomHeaders.headers,
      defaultValues = _useCustomHeaders.defaultValues;

  var _useResponse = (0, _ResponseProvider.useResponse)(),
      setResponse = _useResponse.setResponse;

  var location = (0, _reactRouterDom.useLocation)();

  var _useFetch = (0, _common.useFetch)(),
      fetchHandler = _useFetch.fetchHandler;

  var _useNotification = (0, _Notifications.useNotification)(),
      pushNotification = _useNotification.pushNotification;

  var pathname = location.pathname.replace("/schema", "").replace("/data", "");

  var loadData = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var isData, url, serverResponse;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              isData = location.pathname.startsWith("/data");

              if (!isData) {
                _context.next = 7;
                break;
              }

              url = pathname + location.search;
              _context.next = 5;
              return fetchHandler(url, {
                method: "GET",
                headers: _objectSpread(_objectSpread({
                  accept: "application/json",
                  "Content-Type": "application/json"
                }, headers[pathname] || {}), defaultValues)
              });

            case 5:
              serverResponse = _context.sent;
              setResponse(pathname, {
                get: {
                  status: "ok",
                  code: String(serverResponse === null || serverResponse === void 0 ? void 0 : serverResponse.code) || "-1",
                  body: serverResponse === null || serverResponse === void 0 ? void 0 : serverResponse.body
                }
              }); // setEditable(true);

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function loadData() {
      return _ref2.apply(this, arguments);
    };
  }();

  var pathId = ((0, _utils.getCurrentPath)(api, pathname) || {}).path || "";
  (0, _react.useEffect)(function () {
    loadData(); //eslint-disable-next-line
  }, [location.pathname, location.search]);
  var failedPathID = !tree[getTag(tree, pathId) || ""];
  (0, _react.useEffect)(function () {
    if (failedPathID) {
      var content = "The path ID is undefined";
      pushNotification("error", content);
    } //eslint-disable-next-line

  }, [failedPathID]);
  var path = !failedPathID && tree[getTag(tree, pathId) || ""][pathId];
  return failedPathID ? /*#__PURE__*/_react.default.createElement("div", null) : /*#__PURE__*/_react.default.createElement(_Container.default, null, /*#__PURE__*/_react.default.createElement(_core.Box, {
    my: 6
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true,
    spacing: 3
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: 12
  }, pathname && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Typography.default, {
    variant: "h5"
  }, pathname), /*#__PURE__*/_react.default.createElement(_Typography.default, {
    variant: "subtitle1"
  }, path.summary), /*#__PURE__*/_react.default.createElement(_Typography.default, {
    variant: "subtitle1"
  }, path.description))), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    lg: 8
  }, path && path.parameters && /*#__PURE__*/_react.default.createElement(_Params.default, {
    params: path.parameters,
    form: {}
  })), path && /*#__PURE__*/_react.default.createElement(_Methods.default, {
    path: path,
    url: pathname,
    pathId: pathId
  }))));
};

var _default = Layout;
exports.default = _default;

var getTag = function getTag(schema, path) {
  return Object.keys(schema).find(function (tag) {
    return Object.keys(schema[tag]).includes(path);
  });
};