"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _Box = _interopRequireDefault(require("@material-ui/core/Box"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _Tab = _interopRequireDefault(require("@material-ui/core/Tab"));

var _Tabs = _interopRequireDefault(require("@material-ui/core/Tabs"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _reactJsonViewCompare = _interopRequireDefault(require("react-json-view-compare"));

var _openapiTypes = require("openapi-types");

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _common = require("../common");

var _utils = require("../../utils");

var _CustomHeaderProvider = require("../CustomHeaderProvider");

var _Params = _interopRequireDefault(require("../Params"));

var _RequestBodyProvider = require("../RequestBodyProvider");

var _ResponseProvider = require("../ResponseProvider");

var _Responses = _interopRequireDefault(require("../Responses"));

var _ConfirmationDialog = _interopRequireDefault(require("../ConfirmationDialog"));

var _ResponseForm = _interopRequireDefault(require("./ResponseForm"));

var _TabPanel = _interopRequireDefault(require("./TabPanel"));

var _utils2 = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var MethodForm = function MethodForm(_ref) {
  var path = _ref.path,
      method = _ref.method,
      url = _ref.url,
      pathId = _ref.pathId,
      onGoTo = _ref.onGoTo;
  var history = (0, _reactRouterDom.useHistory)();
  var location = (0, _reactRouterDom.useLocation)();

  var _useRequestBody = (0, _RequestBodyProvider.useRequestBody)(),
      requestBody = _useRequestBody.requestBody;

  var _useFetch = (0, _common.useFetch)(),
      fetchHandler = _useFetch.fetchHandler;

  var pathname = location.pathname.replace("/schema", "").replace("/data", "");
  var defaultFormData = requestBody && requestBody[pathId] && requestBody[pathId][method];

  var _React$useState = _react.default.useState(defaultFormData || {}),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      formData = _React$useState2[0],
      setFormData = _React$useState2[1];

  var _React$useState3 = _react.default.useState({}),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      paramForm = _React$useState4[0],
      setParamForm = _React$useState4[1];

  var _React$useState5 = _react.default.useState({}),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      requestBodyForm = _React$useState6[0],
      setRequestBodyForm = _React$useState6[1];

  var _React$useState7 = _react.default.useState(!!defaultFormData),
      _React$useState8 = _slicedToArray(_React$useState7, 2),
      editable = _React$useState8[0],
      setEditable = _React$useState8[1];

  var _React$useState9 = _react.default.useState(0),
      _React$useState10 = _slicedToArray(_React$useState9, 2),
      activeTab = _React$useState10[0],
      setActiveTab = _React$useState10[1];

  var _React$useState11 = _react.default.useState(false),
      _React$useState12 = _slicedToArray(_React$useState11, 2),
      confirmActive = _React$useState12[0],
      setConfirmActive = _React$useState12[1];

  var preFilled = !!defaultFormData; // const [responseEditable, setResponseEditable] = React.useState(false);

  var _useCustomHeaders = (0, _CustomHeaderProvider.useCustomHeaders)(),
      setHeaders = _useCustomHeaders.setHeaders,
      headers = _useCustomHeaders.headers,
      defaultValues = _useCustomHeaders.defaultValues;

  var _useResponse = (0, _ResponseProvider.useResponse)(),
      responses = _useResponse.responses;

  var response = responses[pathname] && responses[pathname] && responses[pathname][method];

  var toggleEditable = function toggleEditable() {
    setEditable(!editable);
  };

  var schema = (0, _utils.getRequestSchema)(path, method);
  var hasSchema = Object.values(schema || {}).length > 0; // const hasForm = Boolean(schema && Object.values(schema).length > 0);

  var operation = path[method];
  var hasParams = operation.parameters && operation.parameters.length; // const hasResponses = operation.responses && operation.responses.length;

  var responseSchema = !!response ? (0, _utils.getResponseSchema)(path, method, response.code) : {}; // const hasResponseSchema = Object.values(responseSchema || {}).length > 0;

  var responseData = response && response.body;

  var requestConfirm = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setConfirmActive(true);

            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function requestConfirm() {
      return _ref2.apply(this, arguments);
    };
  }();

  var executeGet = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      var query;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              query = (0, _utils2.parseParams)(url, operation.parameters, paramForm);
              setHeaders(_defineProperty({}, pathname, query.headers));
              history.push("/data".concat(query.url));

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function executeGet() {
      return _ref3.apply(this, arguments);
    };
  }();

  var onConfirm = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(success) {
      var serverResponse;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              setConfirmActive(false);

              if (!success) {
                _context3.next = 7;
                break;
              }

              console.log("SEND ", requestBodyForm);
              _context3.next = 5;
              return fetchHandler(url, {
                method: method.toUpperCase(),
                headers: _objectSpread(_objectSpread({
                  accept: "application/json",
                  "Content-Type": "application/json"
                }, headers[pathname] || {}), defaultValues),
                body: JSON.stringify(requestBodyForm)
              });

            case 5:
              serverResponse = _context3.sent;
              console.log("got method", method, serverResponse);

            case 7:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function onConfirm(_x) {
      return _ref4.apply(this, arguments);
    };
  }();

  var handleChange = function handleChange(event, newValue) {
    setActiveTab(newValue);
  };

  var a11yProps = function a11yProps(index) {
    return {
      id: "scrollable-auto-tab-".concat(index),
      "aria-controls": "scrollable-auto-tabpanel-".concat(index)
    };
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
    paddingBottom: 2
  }, /*#__PURE__*/_react.default.createElement(_Typography.default, {
    variant: "subtitle2"
  }, operation.description)), /*#__PURE__*/_react.default.createElement(_AppBar.default, {
    position: "static"
  }, /*#__PURE__*/_react.default.createElement(_Toolbar.default, {
    variant: "dense"
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    sm: 6
  }, /*#__PURE__*/_react.default.createElement(_Tabs.default, {
    value: activeTab,
    onChange: handleChange,
    "aria-label": "simple tabs example"
  }, hasParams && /*#__PURE__*/_react.default.createElement(_Tab.default, _extends({
    label: "Parameters"
  }, a11yProps(0))), /*#__PURE__*/_react.default.createElement(_Tab.default, _extends({
    label: "Responses"
  }, a11yProps(1))))), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    sm: 6
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true,
    direction: "row",
    justify: "flex-end"
  }, !preFilled && /*#__PURE__*/_react.default.createElement(_Button.default, {
    variant: "outlined",
    color: !editable ? "inherit" : "secondary",
    onClick: toggleEditable,
    size: "small"
  }, editable ? "cancel" : "try it out"))))), operation.parameters && operation.parameters.length && /*#__PURE__*/_react.default.createElement(_TabPanel.default, {
    index: 0,
    value: activeTab
  }, /*#__PURE__*/_react.default.createElement(_Params.default, {
    params: operation.parameters,
    editable: editable,
    form: paramForm,
    onChange: setParamForm
  })), operation.responses && /*#__PURE__*/_react.default.createElement(_TabPanel.default, {
    index: hasParams ? 1 : 0,
    value: activeTab
  }, /*#__PURE__*/_react.default.createElement(_Responses.default, {
    responses: operation.responses
  })), hasSchema && /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true
  }, /*#__PURE__*/_react.default.createElement(_ResponseForm.default, {
    title: "Request body",
    schema: schema,
    pathId: pathId,
    formData: formData,
    onEdit: setRequestBodyForm,
    onGoTo: onGoTo
  })), /*#__PURE__*/_react.default.createElement(_Box.default, {
    mt: 2,
    mb: 4
  }, /*#__PURE__*/_react.default.createElement(_Button.default, {
    color: "primary",
    variant: "contained",
    disabled: !editable,
    fullWidth: true,
    onClick: method === _openapiTypes.OpenAPIV3.HttpMethods.GET ? executeGet : requestConfirm
  }, "Execute"), /*#__PURE__*/_react.default.createElement(_ConfirmationDialog.default, {
    title: "".concat(method.toUpperCase(), ": ").concat(url),
    open: confirmActive,
    onClose: onConfirm
  }, /*#__PURE__*/_react.default.createElement(_reactJsonViewCompare.default, {
    oldData: defaultFormData || {},
    newData: requestBodyForm || {}
  }), ";")), responseData && /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true
  }, /*#__PURE__*/_react.default.createElement(_ResponseForm.default, {
    title: "Server Response",
    pathId: pathId,
    schema: responseSchema,
    formData: responseData,
    onGoTo: onGoTo
  })));
};

var _default = MethodForm;
exports.default = _default;