"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _Box = _interopRequireDefault(require("@material-ui/core/Box"));

var _blue = _interopRequireDefault(require("@material-ui/core/colors/blue"));

var _green = _interopRequireDefault(require("@material-ui/core/colors/green"));

var _orange = _interopRequireDefault(require("@material-ui/core/colors/orange"));

var _purple = _interopRequireDefault(require("@material-ui/core/colors/purple"));

var _red = _interopRequireDefault(require("@material-ui/core/colors/red"));

var _teal = _interopRequireDefault(require("@material-ui/core/colors/teal"));

var _yellow = _interopRequireDefault(require("@material-ui/core/colors/yellow"));

var _styles = require("@material-ui/core/styles");

var _Tab = _interopRequireDefault(require("@material-ui/core/Tab"));

var _Tabs = _interopRequireDefault(require("@material-ui/core/Tabs"));

var _openapiTypes = require("openapi-types");

var _react = _interopRequireDefault(require("react"));

var _MethodForm = _interopRequireDefault(require("./MethodForm"));

var _reactRouter = require("react-router");

var _excluded = ["children", "value", "index"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var HttpMethods = Object.values(_openapiTypes.OpenAPIV3.HttpMethods);

function TabPanel(props) {
  var children = props.children,
      value = props.value,
      index = props.index,
      other = _objectWithoutProperties(props, _excluded);

  return /*#__PURE__*/_react.default.createElement("div", _extends({
    role: "tabpanel",
    hidden: value !== index,
    id: "scrollable-auto-tabpanel-".concat(index),
    "aria-labelledby": "scrollable-auto-tab-".concat(index)
  }, other), value === index && /*#__PURE__*/_react.default.createElement(_Box.default, {
    p: 3
  }, children));
}

function a11yProps(index) {
  return {
    id: "scrollable-auto-tab-".concat(index),
    "aria-controls": "scrollable-auto-tabpanel-".concat(index)
  };
}

var useStyles = (0, _styles.makeStyles)(function (theme) {
  var _ref;

  return _ref = {
    root: {
      flexGrow: 1,
      width: "100%",
      backgroundColor: theme.palette.background.paper
    }
  }, _defineProperty(_ref, "indicator-" + _openapiTypes.OpenAPIV3.HttpMethods["GET"], {
    backgroundColor: _blue.default["400"]
  }), _defineProperty(_ref, "indicator-" + _openapiTypes.OpenAPIV3.HttpMethods["DELETE"], {
    backgroundColor: _red.default["400"]
  }), _defineProperty(_ref, "indicator-" + _openapiTypes.OpenAPIV3.HttpMethods["POST"], {
    backgroundColor: _green.default["400"]
  }), _defineProperty(_ref, "indicator-" + _openapiTypes.OpenAPIV3.HttpMethods["PATCH"], {
    backgroundColor: _teal.default["400"]
  }), _defineProperty(_ref, "indicator-" + _openapiTypes.OpenAPIV3.HttpMethods["PUT"], {
    backgroundColor: _orange.default["400"]
  }), _defineProperty(_ref, "indicator-" + _openapiTypes.OpenAPIV3.HttpMethods["OPTIONS"], {
    backgroundColor: _blue.default["900"]
  }), _defineProperty(_ref, "indicator-" + _openapiTypes.OpenAPIV3.HttpMethods["HEAD"], {
    backgroundColor: _purple.default["900"]
  }), _defineProperty(_ref, "indicator-" + _openapiTypes.OpenAPIV3.HttpMethods["TRACE"], {
    backgroundColor: _yellow.default["400"]
  }), _defineProperty(_ref, _openapiTypes.OpenAPIV3.HttpMethods["GET"], {
    color: _blue.default["400"]
  }), _defineProperty(_ref, _openapiTypes.OpenAPIV3.HttpMethods["DELETE"], {
    color: _red.default["400"]
  }), _defineProperty(_ref, _openapiTypes.OpenAPIV3.HttpMethods["POST"], {
    color: _green.default["400"]
  }), _defineProperty(_ref, _openapiTypes.OpenAPIV3.HttpMethods["PATCH"], {
    color: _teal.default["400"]
  }), _defineProperty(_ref, _openapiTypes.OpenAPIV3.HttpMethods["PUT"], {
    color: _orange.default["400"]
  }), _defineProperty(_ref, _openapiTypes.OpenAPIV3.HttpMethods["OPTIONS"], {
    color: _blue.default["900"]
  }), _defineProperty(_ref, _openapiTypes.OpenAPIV3.HttpMethods["HEAD"], {
    color: _purple.default["400"]
  }), _defineProperty(_ref, _openapiTypes.OpenAPIV3.HttpMethods["TRACE"], {
    color: _yellow.default["400"]
  }), _ref;
});

var Methods = function Methods(_ref2) {
  var path = _ref2.path,
      url = _ref2.url,
      pathId = _ref2.pathId;
  var classes = useStyles();
  var history = (0, _reactRouter.useHistory)();
  var allowedMethods = sortMethods(Object.keys(path).filter(function (k) {
    return HttpMethods.includes(k);
  }));
  var defaultTab = allowedMethods.indexOf("GET") >= 0 ? allowedMethods.indexOf("GET") : 0;

  var _React$useState = _react.default.useState(defaultTab),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      value = _React$useState2[0],
      setValue = _React$useState2[1];

  var handleChange = function handleChange(event, newValue) {
    setValue(newValue);
  };

  var goTo = function goTo(path, method) {
    if (path === pathId) {
      var tab = allowedMethods.indexOf(method);
      console.log(allowedMethods, tab);
      setValue(tab);
    } else {
      console.log("goto", pathId, path);
      history.push("/schema".concat(path));
    }
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/_react.default.createElement(_AppBar.default, {
    position: "static",
    color: "default"
  }, /*#__PURE__*/_react.default.createElement(_Tabs.default, {
    value: value,
    onChange: handleChange // indicatorColor="primary"
    // textColor="primary"
    ,
    classes: {
      indicator: classes["indicator-" + allowedMethods[value]]
    },
    variant: "scrollable",
    scrollButtons: "auto",
    "aria-label": "Method list"
  }, allowedMethods.map(function (method) {
    return /*#__PURE__*/_react.default.createElement(_Tab.default, _extends({
      key: method,
      label: method
    }, a11yProps(0), {
      classes: {
        selected: classes[method]
      }
    }));
  }))), allowedMethods.map(function (method, index) {
    return /*#__PURE__*/_react.default.createElement(TabPanel, {
      value: value,
      index: index,
      key: method
    }, path[method] ? /*#__PURE__*/_react.default.createElement(_MethodForm.default, {
      path: path,
      method: method,
      url: url,
      pathId: pathId,
      onGoTo: goTo
    }) : /*#__PURE__*/_react.default.createElement("div", null, "no form"));
  }));
};

var _default = Methods;
exports.default = _default;
var methodOrder = {
  get: 1,
  post: 2,
  put: 3,
  patch: 4,
  delete: 5,
  options: 6,
  head: 7,
  trace: 8
};

var sortMethods = function sortMethods(methods) {
  return methods.sort(function (m1, m2) {
    return methodOrder[m1] - methodOrder[m2];
  });
};