"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseParams = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var parseParams = function parseParams(path, params, values) {
  return params.reduce(function (qobj, param) {
    if (param.in === "path") {
      return _objectSpread(_objectSpread({}, qobj), {}, {
        url: qobj.url.replace("{".concat(param.name, "}"), values[param.name])
      });
    } else if (param.in === "query") {
      var prefix = qobj.url.includes("?") ? "&" : "?";
      return _objectSpread(_objectSpread({}, qobj), {}, {
        url: "".concat(qobj.url).concat(prefix).concat(param.name, "=").concat(values[param.name])
      });
    } else if (param.in === "header") {
      return _objectSpread(_objectSpread({}, qobj), {}, {
        headers: _objectSpread(_objectSpread({}, qobj.headers), {}, _defineProperty({}, param.name, values[param.name]))
      });
    } else {
      //TODO: Implement cookie params
      return qobj;
    }
  }, {
    url: path,
    headers: {}
  });
};

exports.parseParams = parseParams;