"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.NestedMenu = void 0;

var _react = _interopRequireWildcard(require("react"));

var _core = require("@material-ui/core");

var _materialUiNestedMenuItem = _interopRequireDefault(require("material-ui-nested-menu-item"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Item = function Item(_ref) {
  var label = _ref.label,
      value = _ref.value,
      children = _ref.children,
      onSelect = _ref.onSelect,
      parentOpen = _ref.parentOpen;

  var onClick = function onClick() {
    return onSelect(value);
  };

  if (!children || !children.length) {
    return /*#__PURE__*/_react.default.createElement(_core.MenuItem, {
      onClick: onClick
    }, label);
  }

  return /*#__PURE__*/_react.default.createElement(_materialUiNestedMenuItem.default, {
    label: label,
    parentMenuOpen: parentOpen
  }, children.map(function (item, index) {
    return /*#__PURE__*/_react.default.createElement(Item, _extends({
      key: index
    }, item, {
      onSelect: onSelect,
      parentOpen: parentOpen
    }));
  }));
}; // const dummy = [
//   { label: "one", value: "one" },
//   {
//     label: "one1",
//     value: "2",
//     children: [
//       { label: "one111", value: "4" },
//       { label: "one11", value: "3" },
//     ],
//   },
// ];

/**
 * 
 * @typeParam NestedItem asdf
 * @param label asdf
 * 
 */

/**
 * 
 * @param items array of `NestedItem` 
 * @param title of type string, 
 * @param onSelect of type any, optional, receives value as a parameter for handling item clicks
 * @returns a Material UI menu button
 */


var NestedMenu = function NestedMenu(_ref2) {
  var items = _ref2.items,
      title = _ref2.title,
      onSelect = _ref2.onSelect;

  var _useState = (0, _react.useState)(null),
      _useState2 = _slicedToArray(_useState, 2),
      anchorEl = _useState2[0],
      setAnchorEl = _useState2[1];

  var handleClick = function handleClick(event) {
    setAnchorEl(event.currentTarget);
  };

  var handleClose = function handleClose() {
    setAnchorEl(null);
  };

  var handleItemClick = function handleItemClick(value) {
    onSelect && onSelect(value);
    setAnchorEl(null);
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_core.Button, {
    onClick: handleClick,
    variant: "outlined",
    color: "primary"
  }, title), /*#__PURE__*/_react.default.createElement(_core.Menu, {
    open: Boolean(anchorEl),
    onClose: handleClose // anchorReference="anchorPosition"
    // anchorPosition={menuPosition}
    ,
    anchorEl: anchorEl,
    anchorOrigin: {
      vertical: "bottom",
      horizontal: "left"
    }
  }, items.map(function (d, k) {
    return /*#__PURE__*/_react.default.createElement(Item, _extends({
      key: k
    }, d, {
      onSelect: handleItemClick,
      parentOpen: Boolean(anchorEl)
    }));
  })));
};

exports.NestedMenu = NestedMenu;
var _default = NestedMenu;
exports.default = _default;