"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _OnboardingProviderx = require("../OnboardingProviderx");

var _HelperBadge = _interopRequireDefault(require("../HelperBadge"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OnboardingBadge = function OnboardingBadge(_ref) {
  var step = _ref.step,
      content = _ref.content,
      children = _ref.children;
  var onboarding = (0, _OnboardingProviderx.useOnboarding)();
  console.log("onboadringtest:", onboarding);

  var next = function next() {
    console.log("next");
    onboarding.next();
  }; // Only true for up to 1 badge at a time, if each badge is given a different step prop


  var match = onboarding.step === step;
  var first = onboarding.step === 1;
  var show = match || first;
  var popover = onboarding.popoverProps;
  var badge = onboarding.badgeProps; //if statement

  return /*#__PURE__*/_react.default.createElement(_HelperBadge.default, {
    content: content,
    contentVisible: match,
    badgeVisible: show,
    popoverProps: popover,
    badgeProps: badge
  }, children);
};

var _default = OnboardingBadge;
exports.default = _default;