"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@material-ui/core");

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _styles = require("@material-ui/core/styles");

var _Table = _interopRequireDefault(require("@material-ui/core/Table"));

var _TableBody = _interopRequireDefault(require("@material-ui/core/TableBody"));

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _TableContainer = _interopRequireDefault(require("@material-ui/core/TableContainer"));

var _TableHead = _interopRequireDefault(require("@material-ui/core/TableHead"));

var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));

var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));

var _Cancel = _interopRequireDefault(require("@material-ui/icons/Cancel"));

var _CheckCircle = _interopRequireDefault(require("@material-ui/icons/CheckCircle"));

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useStyles = (0, _styles.makeStyles)({
  table: {
    minWidth: 650
  }
});

var parseExample = function parseExample(param) {
  return param.example || param.examples && param.examples.length && param.examples[0] || param.schema && (param.schema.example || param.schema.examples && param.schema.examples.length && param.schema.examples[0]);
};

var Params = function Params(_ref) {
  var params = _ref.params,
      editable = _ref.editable,
      form = _ref.form,
      onChange = _ref.onChange;
  var classes = useStyles();
  (0, _react.useEffect)(function () {
    onChange && onChange(params.reduce(function (newForm, param) {
      return _objectSpread(_objectSpread({}, newForm), {}, _defineProperty({}, param.name, parseExample(param) || ""));
    }, {})); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);

  var setForm = function setForm(field) {
    return function (evnt) {
      return onChange && onChange(_objectSpread(_objectSpread({}, form), {}, _defineProperty({}, field, evnt.target.value)));
    };
  };

  var hasParams = Boolean(Object.keys(form).length); // TODO: display disabled attribute

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true
  }), /*#__PURE__*/_react.default.createElement(_TableContainer.default, {
    component: _Paper.default
  }, /*#__PURE__*/_react.default.createElement(_Table.default, {
    className: classes.table,
    "aria-label": "simple table",
    size: "small"
  }, /*#__PURE__*/_react.default.createElement(_TableHead.default, null, /*#__PURE__*/_react.default.createElement(_TableRow.default, null, /*#__PURE__*/_react.default.createElement(_TableCell.default, null, "Name"), /*#__PURE__*/_react.default.createElement(_TableCell.default, null, "Example"), /*#__PURE__*/_react.default.createElement(_TableCell.default, null, "Description"), /*#__PURE__*/_react.default.createElement(_TableCell.default, {
    align: "center"
  }, "Allow Empty Value"))), /*#__PURE__*/_react.default.createElement(_TableBody.default, null, hasParams && params.map(function (p) {
    var param = p;
    return param.name ? /*#__PURE__*/_react.default.createElement(_TableRow.default, {
      key: param.name
    }, /*#__PURE__*/_react.default.createElement(_TableCell.default, {
      component: "th",
      scope: "row"
    }, /*#__PURE__*/_react.default.createElement(_core.Typography, {
      color: param.required ? "error" : "initial"
    }, param.name, param.required && /*#__PURE__*/_react.default.createElement(_core.Typography, {
      component: "span"
    }, "*")), /*#__PURE__*/_react.default.createElement(_core.Typography, null, param.in)), /*#__PURE__*/_react.default.createElement(_TableCell.default, null, /*#__PURE__*/_react.default.createElement(_TextField.default, {
      size: "small",
      required: true,
      label: param.name,
      value: form[param.name],
      onChange: setForm(param.name),
      disabled: !editable,
      variant: "outlined"
    })), /*#__PURE__*/_react.default.createElement(_TableCell.default, null, param.description), /*#__PURE__*/_react.default.createElement(_TableCell.default, {
      align: "center"
    }, param.allowEmptyValue ? /*#__PURE__*/_react.default.createElement(_CheckCircle.default, {
      color: "primary"
    }) : /*#__PURE__*/_react.default.createElement(_Cancel.default, {
      color: "disabled"
    }))) : /*#__PURE__*/_react.default.createElement("div", null);
  })))), /*#__PURE__*/_react.default.createElement(_core.Typography, {
    color: "error"
  }, "* required"));
};

var _default = Params;
exports.default = _default;