"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@material-ui/core");

var _Accordion = _interopRequireDefault(require("@material-ui/core/Accordion"));

var _AccordionDetails = _interopRequireDefault(require("@material-ui/core/AccordionDetails"));

var _AccordionSummary = _interopRequireDefault(require("@material-ui/core/AccordionSummary"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _ExpandMore = _interopRequireDefault(require("@material-ui/icons/ExpandMore"));

var _react = _interopRequireDefault(require("react"));

var _SchemaViewer = _interopRequireDefault(require("../SchemaViewer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Responses = function Responses(_ref) {
  var responses = _ref.responses;
  // const classes = useStyles();
  // TODO: display disabled attribute
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Grid.default, null, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    container: true
  }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: 2
  }, /*#__PURE__*/_react.default.createElement(_core.Typography, null, "code")), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    item: true,
    xs: 10
  }, "Description"))), /*#__PURE__*/_react.default.createElement(_Grid.default, null, Object.keys(responses).map(function (code) {
    var response = responses[code];
    return response.description ? /*#__PURE__*/_react.default.createElement(_Accordion.default, {
      key: code
    }, /*#__PURE__*/_react.default.createElement(_AccordionSummary.default, {
      expandIcon: /*#__PURE__*/_react.default.createElement(_ExpandMore.default, null),
      "aria-controls": "panel1a-content",
      id: "panel1a-header"
    }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
      container: true
    }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
      item: true,
      xs: 2
    }, /*#__PURE__*/_react.default.createElement(_core.Typography, null, code)), /*#__PURE__*/_react.default.createElement(_Grid.default, {
      item: true,
      xs: 10
    }, response.description))), /*#__PURE__*/_react.default.createElement(_AccordionDetails.default, {
      style: {
        maxHeight: "400px",
        overflow: "auto"
      }
    }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
      container: true
    }, /*#__PURE__*/_react.default.createElement(_Grid.default, {
      item: true,
      xs: 12
    }, /*#__PURE__*/_react.default.createElement(Response, {
      response: response
    }))))) : /*#__PURE__*/_react.default.createElement("div", null);
  })));
};

var _default = Responses;
exports.default = _default;

var Response = function Response(_ref2) {
  var response = _ref2.response;

  if (!response.content || !response.content["application/json"]) {
    return /*#__PURE__*/_react.default.createElement("div", null, response.description);
  }

  var mediaObject = response.content["application/json"];
  var schema = mediaObject.schema;
  return /*#__PURE__*/_react.default.createElement(_SchemaViewer.default, {
    schema: schema
  });
};