"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@material-ui/core");

var _Box = _interopRequireDefault(require("@material-ui/core/Box"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _ButtonGroup = _interopRequireDefault(require("@material-ui/core/ButtonGroup"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _materialUi = _interopRequireDefault(require("@rjsf/material-ui"));

var _SchemaTable = _interopRequireDefault(require("material-ui-json-schema-viewer/build/SchemaTable"));

var _SourceView = _interopRequireDefault(require("material-ui-json-schema-viewer/build/SourceView"));

var _schemaTree = require("material-ui-json-schema-viewer/src/utils/schemaTree");

var _react = _interopRequireWildcard(require("react"));

var _reactJsonView = _interopRequireDefault(require("react-json-view"));

var _utils = require("../../utils");

var _APIProvider = require("../APIProvider");

var _TabPanel = _interopRequireDefault(require("../Methods/TabPanel"));

var _NestedMenu = _interopRequireDefault(require("../NestedMenu"));

var _RequestBodyProvider = require("../RequestBodyProvider");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// import { getForm } from "../../utils";
// import Params from "../Params";
// import Responses from "../Responses";
var VIEW;

(function (VIEW) {
  VIEW[VIEW["JSON"] = 0] = "JSON";
  VIEW[VIEW["FORM"] = 1] = "FORM";
  VIEW[VIEW["SCHEMA"] = 2] = "SCHEMA";
  VIEW[VIEW["SOURCE"] = 3] = "SOURCE";
})(VIEW || (VIEW = {}));

var SchemaForm = function SchemaForm(_ref) {
  var schema = _ref.schema,
      formData = _ref.formData,
      pathId = _ref.pathId,
      onGoTo = _ref.onGoTo,
      onChange = _ref.onChange;
  var editable = Boolean(onChange);

  var _React$useState = _react.default.useState(editable ? VIEW.FORM : VIEW.JSON),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      view = _React$useState2[0],
      setView = _React$useState2[1];

  var _useState = (0, _react.useState)((0, _schemaTree.createSchemaTree)(schema)),
      _useState2 = _slicedToArray(_useState, 2),
      schemaTree = _useState2[0],
      setSchemaTree = _useState2[1];

  var _React$useState3 = _react.default.useState(formData),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      cacheData = _React$useState4[0],
      setCacheData = _React$useState4[1];

  var api = (0, _APIProvider.useAPI)();

  var _useRequestBody = (0, _RequestBodyProvider.useRequestBody)(),
      setRequestBody = _useRequestBody.setRequestBody;

  var theme = (0, _core.createTheme)({
    palette: {
      type: "dark"
    }
  });
  var relatedOptions = (0, _react.useMemo)(function () {
    var relatedForms = (0, _utils.getRelatedForms)(api);
    return relatedForms && Object.keys(relatedForms[pathId] || []).map(function (path) {
      return {
        label: path,
        value: path,
        children: Object.values(relatedForms[pathId][path]).map(function (method) {
          return {
            label: method,
            value: [path, method]
          };
        })
      };
    }); //eslint-disable-next-line
  }, [pathId]);

  _react.default.useEffect(function () {
    setCacheData(formData);
  }, [formData]); //   const toggleEditable = () => {
  //     console.log("click");
  //     setEditable(!editable);
  //   };


  var onSelectView = function onSelectView(viewtype) {
    return function () {
      return setView(viewtype);
    };
  };

  var onSelectForward = function onSelectForward(_ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
        path = _ref3[0],
        method = _ref3[1];

    setRequestBody(path, _defineProperty({}, method, formData));
    onGoTo(path, method);
  }; // const discardChanges = () => {
  //   setCacheData({ ...formData });
  // };


  var jsonEditable = editable ? {
    onEdit: function onEdit(edit) {
      setCacheData(edit.updated_src);
      onChange && onChange(edit.updated_src);
    },
    onDelete: function onDelete(edit) {
      setCacheData(edit.updated_src);
      onChange && onChange(edit.updated_src);
    },
    onAdd: function onAdd(edit) {
      setCacheData(edit.updated_src);
      onChange && onChange(edit.updated_src);
    }
  } : {};

  var onEditForm = function onEditForm(e) {
    var pristine = removeEmpty(e.formData);
    setCacheData(pristine);
    onChange && onChange(pristine);
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
    mt: 2,
    mb: 1,
    justifyContent: "space-between",
    flexDirection: "row",
    display: "flex"
  }, Boolean(relatedOptions) && Boolean(relatedOptions.length) ? /*#__PURE__*/_react.default.createElement(_NestedMenu.default, {
    items: relatedOptions,
    title: "Edit as",
    onSelect: onSelectForward
  }) : /*#__PURE__*/_react.default.createElement("div", null), /*#__PURE__*/_react.default.createElement(_ButtonGroup.default, {
    variant: "text",
    color: "primary",
    "aria-label": "text primary button group"
  }, /*#__PURE__*/_react.default.createElement(_Button.default, {
    variant: view === VIEW.JSON ? "contained" : undefined,
    onClick: onSelectView(VIEW.JSON)
  }, "JSON View"), editable && /*#__PURE__*/_react.default.createElement(_Button.default, {
    variant: view === VIEW.FORM ? "contained" : undefined,
    onClick: onSelectView(VIEW.FORM)
  }, "FORM View"), /*#__PURE__*/_react.default.createElement(_Button.default, {
    variant: view === VIEW.SCHEMA ? "contained" : undefined,
    onClick: onSelectView(VIEW.SCHEMA)
  }, "SCHEMA View"), /*#__PURE__*/_react.default.createElement(_Button.default, {
    variant: view === VIEW.SOURCE ? "contained" : undefined,
    onClick: onSelectView(VIEW.SOURCE)
  }, "SOURCE View"))), /*#__PURE__*/_react.default.createElement(_Grid.default, {
    style: {
      maxHeight: "75vh",
      overflow: "auto"
    }
  }, /*#__PURE__*/_react.default.createElement(_TabPanel.default, {
    index: VIEW.JSON,
    value: view
  }, /*#__PURE__*/_react.default.createElement(_reactJsonView.default, _extends({
    src: cacheData,
    theme: "monokai",
    iconStyle: "triangle"
  }, jsonEditable, {
    enableClipboard: function enableClipboard(copy) {
      var src = copy.src;

      if (typeof src === "string") {
        if (!navigator.clipboard) {
          var container = document.createElement("textarea");
          document.body.appendChild(container);
          container.innerHTML = src;
          container.select();
          document.execCommand("copy");
          document.body.removeChild(container);
        } else {
          navigator.clipboard.writeText(src);
        }
      }
    }
  }))), editable && /*#__PURE__*/_react.default.createElement(_TabPanel.default, {
    index: VIEW.FORM,
    value: view
  }, /*#__PURE__*/_react.default.createElement(_materialUi.default, {
    schema: schema // uiSchema={ui}
    ,
    formData: cacheData,
    onChange: onEditForm,
    onError: function onError(e) {
      return console.log("ERROR", formData);
    }
  }, /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null))), /*#__PURE__*/_react.default.createElement(_core.ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/_react.default.createElement(_TabPanel.default, {
    index: VIEW.SCHEMA,
    value: view
  }, /*#__PURE__*/_react.default.createElement(_SchemaTable.default, {
    schemaTree: schemaTree,
    setSchemaTree: setSchemaTree,
    references: []
  })), /*#__PURE__*/_react.default.createElement(_TabPanel.default, {
    index: VIEW.SOURCE,
    value: view
  }, /*#__PURE__*/_react.default.createElement(_SourceView.default, {
    schema: schema
  })))));
};

var _default = SchemaForm; // const ui = {
//   "ui:page": {
//     props: {
//       "ui:schemaErrors": true,
//     },
//     style: {
//       boxShadow: "none",
//     },
//   },
//   base_date: {
//     "ui:widget": "DateWidget",
//   },
//   base_year: {
//     // "ui:widget": "material-date",
//     "ui:widget": "updown",
//   },
//   number: {
//     // "ui:widget": "updown",
//   },
// };

exports.default = _default;

var removeEmpty = function removeEmpty(obj) {
  if (_typeof(obj) !== "object" || Array.isArray(obj)) {
    return obj;
  } else {
    if (!Object.values(obj).length) {
      return undefined;
    } else {
      var partial = Object.keys(obj).reduce(function (acc, key) {
        var value = removeEmpty(obj[key]);
        return value !== undefined ? _objectSpread(_objectSpread({}, acc), {}, _defineProperty({}, key, value)) : acc;
      }, {});
      return Object.values(partial).length ? partial : undefined;
    }
  }
};