"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useFetch = void 0;

var _Notifications = require("./Notifications");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var useFetch = function useFetch() {
  var _useNotification = (0, _Notifications.useNotification)(),
      pushNotification = _useNotification.pushNotification;

  var fetchHandler = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(url, params) {
      var res, body, _body, content;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return fetch("https://indexapi.aws.merqurian.com" + url, params);

            case 3:
              res = _context.sent;

              if (!res.ok) {
                _context.next = 12;
                break;
              }

              _context.next = 7;
              return res.json();

            case 7:
              body = _context.sent;
              pushNotification("success", "".concat(res.status, " ").concat(res.statusText, " - ").concat(res.url));
              return _context.abrupt("return", {
                code: res.status,
                body: body
              });

            case 12:
              _context.next = 14;
              return res.json();

            case 14:
              _body = _context.sent;
              content = "".concat(res.status, " ").concat(res.statusText, " - ").concat(_body.error);
              pushNotification("error", content);
              console.error(content);

            case 18:
              _context.next = 23;
              break;

            case 20:
              _context.prev = 20;
              _context.t0 = _context["catch"](0);
              console.error(_context.t0);

            case 23:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 20]]);
    }));

    return function fetchHandler(_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  return {
    fetchHandler: fetchHandler
  };
};

exports.useFetch = useFetch;