import { OpenAPIV3 } from "openapi-types";
export interface SchemaTree {
    [tag: string]: {
        [path: string]: {
            [method in OpenAPIV3.HttpMethods]: OpenAPIV3.OperationObject;
        };
    };
}
declare const parseSchema: (api: OpenAPIV3.Document) => SchemaTree;
export default parseSchema;
declare function getRef<T>(API: OpenAPIV3.Document, refPath: string): T;
declare function parseRef<T>(API: OpenAPIV3.Document, item: T | OpenAPIV3.ReferenceObject): T;
declare function fillRefs(API: OpenAPIV3.Document, dict: any): any;
declare const getRequestSchema: (path: OpenAPIV3.PathItemObject, method: OpenAPIV3.HttpMethods) => OpenAPIV3.ReferenceObject | OpenAPIV3.SchemaObject | undefined;
declare const getResponseSchema: (path: OpenAPIV3.PathItemObject, method: OpenAPIV3.HttpMethods, code: number) => OpenAPIV3.ReferenceObject | OpenAPIV3.SchemaObject | undefined;
interface RelatedMap {
    [pattern: string]: {
        [method in OpenAPIV3.HttpMethods]?: {
            [pattern: string]: OpenAPIV3.HttpMethods[];
        };
    };
}
declare const getRelatedForms: (API: OpenAPIV3.Document) => RelatedMap;
interface PathResult {
    match: RegExpMatchArray;
    path: string;
}
declare const getCurrentPath: (api: OpenAPIV3.Document, pathname: string) => PathResult | null | undefined;
export { getRef, parseRef, parseSchema, getRequestSchema, getResponseSchema, fillRefs, getRelatedForms, getCurrentPath, };
